=== debian/watch ===
version=3

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/codelite-$1\.tar\.gz/,dversionmangle=s/\+dfsg\d?$// \
  https://github.com/eranif/codelite/tags .*/v?(\d\S*)\.tar\.gz
